Package ghidra.app.util.opinion

# Class BoundedBufferedReader

java.lang.Object
java.io.Reader
ghidra.app.util.opinion.BoundedBufferedReader

All Implemented Interfaces:
  `Closeable`, `AutoCloseable`, `Readable`

public class BoundedBufferedReader extends Reader

- ## Field Summary

  ### Fields inherited from class java.io.Reader

  `lock`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `BoundedBufferedReader(Reader in)`
  Creates a buffering character-input stream that uses a default-sized input buffer.
  `BoundedBufferedReader(Reader in, int sz)`
  Creates a buffering character-input stream that uses an input buffer of the specified size.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `close()`
  `void`
  `mark(int readAheadLimit)`
  Marks the present position in the stream.
  `boolean`
  `markSupported()`
  Tells whether this stream supports the mark() operation, which it does.
  `int`
  `read()`
  Reads a single character.
  `int`
  `read(char[] cbuf, int off, int len)`
  Reads characters into a portion of an array.
  `String`
  `readLine()`
  Reads a line of text.
  `boolean`
  `ready()`
  Tells whether this stream is ready to be read.
  `void`
  `reset()`
  Resets the stream to the most recent mark.
  `long`
  `skip(long n)`
  Skips characters.

  ### Methods inherited from class java.io.Reader

  `nullReader, read, read, transferTo`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Constructor Details

  - ### BoundedBufferedReader

    public BoundedBufferedReader(Reader in, int sz)
    Creates a buffering character-input stream that uses an input buffer of the specified size.
    Parameters:
      `in` - A Reader
      `sz` - Input-buffer size
    Throws:
      `IllegalArgumentException` - If sz is <= 0

  - ### BoundedBufferedReader

    public BoundedBufferedReader(Reader in)
    Creates a buffering character-input stream that uses a default-sized input buffer.
    Parameters:
      `in` - A Reader

- ## Method Details

  - ### read

    public int read() throws IOException
    Reads a single character.
    Overrides:
      `read` in class `Reader`
    Returns:
      The character read, as an integer in the range 0 to 65535 ( `0x00-0xffff`), or -1 if the end of the stream has been reached
    Throws:
      `IOException` - If an I/O error occurs

  - ### read

    public int read(char[] cbuf, int off, int len) throws IOException
    Reads characters into a portion of an array.

    This method implements the general contract of the corresponding ``read`` method of the ``Reader`` class. As an additional convenience, it attempts to read as many characters as possible by repeatedly invoking the `read` method of the underlying stream. This iterated `read` continues until one of the following conditions becomes true:

    - The specified number of characters have been read,
    - The `read` method of the underlying stream returns `-1`, indicating end-of-file, or
    - The `ready` method of the underlying stream returns `false`, indicating that further input requests would block.
    If the first `read` on the underlying stream returns `-1` to indicate end-of-file then this method returns `-1`. Otherwise this method returns the number of characters actually read.

    Subclasses of this class are encouraged, but not required, to attempt to read as many characters as possible in the same fashion.

    Ordinarily this method takes characters from this stream's character buffer, filling it from the underlying stream as necessary. If, however, the buffer is empty, the mark is not valid, and the requested length is at least as large as the buffer, then this method will read characters directly from the underlying stream into the given array. Thus redundant `BufferedReader`s will not copy data unnecessarily.

    Specified by:
      `read` in class `Reader`
    Parameters:
      `cbuf` - Destination buffer
      `off` - Offset at which to start storing characters
      `len` - Maximum number of characters to read
    Returns:
      The number of characters read, or -1 if the end of the stream has been reached
    Throws:
      `IOException` - If an I/O error occurs

  - ### readLine

    public String readLine() throws IOException
    Reads a line of text. A line is considered to be terminated by any one of a line feed ('\n'), a carriage return ('\r'), or a carriage return followed immediately by a linefeed.
    Returns:
      A String containing the contents of the line, not including any line-termination characters, or null if the end of the stream has been reached
    Throws:
      `IOException` - If an I/O error occurs

  - ### skip

    public long skip(long n) throws IOException
    Skips characters.
    Overrides:
      `skip` in class `Reader`
    Parameters:
      `n` - The number of characters to skip
    Returns:
      The number of characters actually skipped
    Throws:
      `IllegalArgumentException` - If `n` is negative.
      `IOException` - If an I/O error occurs

  - ### ready

    public boolean ready() throws IOException
    Tells whether this stream is ready to be read. A buffered character stream is ready if the buffer is not empty, or if the underlying character stream is ready.
    Overrides:
      `ready` in class `Reader`
    Throws:
      `IOException` - If an I/O error occurs

  - ### markSupported

    public boolean markSupported()
    Tells whether this stream supports the mark() operation, which it does.
    Overrides:
      `markSupported` in class `Reader`

  - ### mark

    public void mark(int readAheadLimit) throws IOException
    Marks the present position in the stream. Subsequent calls to reset() will attempt to reposition the stream to this point.
    Overrides:
      `mark` in class `Reader`
    Parameters:
      `readAheadLimit` - Limit on the number of characters that may be read while still preserving the mark. An attempt to reset the stream after reading characters up to this limit or beyond may fail. A limit value larger than the size of the input buffer will cause a new buffer to be allocated whose size is no smaller than limit. Therefore large values should be used with care.
    Throws:
      `IllegalArgumentException` - If readAheadLimit is < 0
      `IOException` - If an I/O error occurs

  - ### reset

    public void reset() throws IOException
    Resets the stream to the most recent mark.
    Overrides:
      `reset` in class `Reader`
    Throws:
      `IOException` - If the stream has never been marked, or if the mark has been invalidated

  - ### close

    public void close() throws IOException
    Specified by:
      `close` in interface `AutoCloseable`
    Specified by:
      `close` in interface `Closeable`
    Specified by:
      `close` in class `Reader`
    Throws:
      `IOException`